class Pot {
	private int content = 0;
	
	public int getContent() {
		return content;
	}
	
	public void put(int n) {
		content += n;
	}
	
	public void take() {
		if (content <= 0) {
			throw new IllegalStateException("Topf ist leer");
		}
		content--;
	}
}

class Savage implements Runnable {
	private Pot pot;
	
	public Savage(Pot p) {
		pot = p;
	}
	
	public void run() {
		while (pot.getContent() > 0) {
			try {
				Thread.sleep(10);
				pot.take();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}

class Main {
	public static void main(String[] args) {
		Pot pot = new Pot();
		pot.put(1000);
		new Thread(new Savage(pot)).start();
		new Thread(new Savage(pot)).start();
	}
}