class A implements Runnable {
	private Object o1;
	private Object o2;
	
	public A(Object o1, Object o2) {
		this.o1 = o1;
		this.o2 = o2;
	}
	
	public void run() {
		for (int i = 0; i < 100; i++) {
			synchronized (o1) {
				synchronized (o2) {
					try {
						System.out.println(
							Thread.currentThread().getName()
							+ ": " + i);
						Thread.sleep(100);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		}
	}
}

class Main {
	public static void main(String[] args) {
		String x = "foo";
		String y = "bar";
		
		new Thread(new A(x, y)).start();
		new Thread(new A(y, x)).start();
	}
}