#include <iostream>
using namespace std;

class U {
public:
	int x;
	U(int x);
	virtual int getX();
	void setX(int x);
};

class L : public U {
public:
	L(int x);
	virtual int getX();
	void setX(int x);
};

U::U(int x) : x(x) {}

int U::getX() {
	return x;
}

void U::setX(int x) {
	this->x = x;
}

L::L(int x) : U(2 * x) {}

int L::getX() {
	return x * 3;
}

void L::setX(int x) {
	this->x = 2 * x;
}

int main() {
	L l = L(1);
	U u = l;

	U& uRe1 = l;
	U& uRe2 = u;

	L* low = &l;
	U* up = low;

	cout << l.x << " " << l.getX() << endl;
	l.setX(10);
	cout << l.x << " " << l.getX() << endl;

	cout << u.x << " " << u.getX() << endl;
	u.setX(10);
	cout << u.x << " " << u.getX() << endl;

	cout << uRe1.x << " " << uRe1.getX() << endl;
	uRe1.setX(10);
	cout << uRe1.x << " " << uRe1.getX() << endl;

	cout << uRe2.x << " " << uRe2.getX() << endl;
	uRe2.setX(100);
	cout << uRe2.x << " " << uRe2.getX() << endl;

	cout << low->x << " " << low->getX() << endl;
	low->setX(1000);
	cout << low->x << " " << low->getX() << endl;

	cout << up->x << " " << up->getX() << endl;
	up->setX(10000);
	cout << up->x << " " << up->getX() << endl;

	return 0;
}