#include <iostream> 
using namespace std; 

template <class T> class Box { 
public: 
	T content; 
	
	Box<T>(T x) : content(x) {}; 
}; 

template <typename T> void fB(Box<T> b) { 
	T x = 2 * b.content; 
	b = Box<T>(x); 
	b.content = 42; 
} 

int main() { 
	Box<int> b(17); 
	fB(b); 
	cout << b.content << endl; 
	Box<int>& c = b; 
	fB(c); 
	cout << b.content << endl; 
} 
