#include <iostream> 

class C { 
public: 
	int counter; 
	C();
	int next();
}; 

C::C() : counter(42) {}

int C::next() {
	counter = counter + 1;
	if (counter > 43) { 
		counter = 0; 
		throw 17; 
	} 
	return counter; 
} 

int main() { 
	C c; 
	try { 
		std::cout << c.next() << std::endl; 
		std::cout << c.next() << std::endl; 
		std::cout << c.next() << std::endl; 
		std::cout << c.next() << std::endl; 
	} catch (std::string s) { 
		std::cout << s << std::endl; 
		std::cout << c.next() << std::endl; 
	} catch (int i) { 
		if (i == 42) { 
			std::cout << c.next() << std::endl; 
			std::cout << c.next() << std::endl; 
		} else { 
			std::cout << "unknown error: " << i << std::endl; 
			std::cout << c.next() << std::endl; 
		} 
	} 
} 