#include <iostream>

class A {
public:
	int x;
};

class B : public A {
public:
	bool check() const;
};

class C : public A {
public:
	void increment();
};

class D : public B, public C {
public:
	bool incrementAndCheck();
};

bool B::check() const {
	return (x == 42);
}

void C::increment() {
	++x;
}

bool D::incrementAndCheck() {
	increment();
	return check();
}

int main() {
	D d;
	d.x = 41;
	std::cout << d.incrementAndCheck() << std::endl;
	std::cout << d.x << std::endl;
	return 0;
}