class A {
public:
	A(int x);
	virtual void modify()=0;
protected:
	int x;
};

class B : A {
public:
	B(int x);
	virtual void modify();
};

A::A(int x) : x(x) {}

B::B(int x) : A(x) {}

virtual void B::modify() {
	x *= 2;
}

int main() {
	B b(21);
	b.modify();
	return 0;
}