#include <iostream> 

class O { 
public: 
	int x; 
	O(int x);
	virtual void print();
}; 

class U : public O {
public: 
	U(int x);
	virtual void print();
}; 

O::O(int x) : x(x) {} 

void O::print() { 
	std::cout << x << std::endl;
} 

U::U(int x) : O(x) {} 

void U::print() { 
	std::cout << (x * 2) << std::endl;
} 

void print(O& o) { 
	o.x = o.x + 4 ; 
	o.print(); 
} 

int main() { 
	U u(17); 
	print(u); 
	std::cout << u.x << std::endl; 
	O o = u; 
	print(o); 
	std::cout << o.x << std::endl; 
	return 0; 
} 
