#include <iostream>

class C {
public:
	int x;
	int y;
	C(int x);
	C(const C& other);
};

C::C(int x) : x(x), y(42) {}

C::C(const C& other) : x(other.x + 1), y(2 * other.y) {}

int main() {
	C c1 = 17;
	C c2 = c1;
	std::cout << c1.x << ", " << c1.y << std::endl;
	std::cout << c2.x << ", " << c2.y << std::endl;
}