#include <iostream>

class C {
public:
	int counter;
	C();
	int nextOdd();
};

C::C() : counter(0) {}

int C::nextOdd() {
	counter++;
	if (counter % 2 == 0) throw 42;
	return counter;
}

int main() {
	C c;
	try {
		std::cout << c.nextOdd() << std::endl;
		std::cout << c.nextOdd() << std::endl;
		std::cout << c.nextOdd() << std::endl;
		std::cout << c.nextOdd() << std::endl;
	} catch (std::string s) {
		std::cout << s << std::endl;
	} catch (int i) {
		if (i == 42) {
			std::cout << c.nextOdd() << std::endl;
		} else {
			std::cout << "unknown error: " << i << std::endl;
		}
	}
}