#include <iostream>
using namespace std;

class C {
public:
	int x;
	C(int x);
	virtual ~C();
	int operator()(int y);
};

C::C(int x) : x(x) {}

C::~C() {
	this->x = 42;
	cout << x << endl;
}

int C::operator()(int y) {
	x += y;
	return x;
}

int main() {
	C* c1 = new C(17);
	C c2 = *c1;
	cout << c2(5) << endl;
	cout << (*c1)(5) << endl;
	cout << c1->x << endl;
	delete c1;
	cout << c2.x << endl;
	return 0;
}