#include <iostream>
using namespace std;

class C {
public:
	int x;
	C(int x);
	virtual void setX(int x);
	virtual int getX();
};

C::C(int x) : x(x) {}

void C::setX(int x) {
	this->x = x;
}

int C::getX() {
	return x;
}

int f(C c) {
	c.setX(2 * c.getX());
	return c.x;
}

int main() {
	C* c = new C(17);
	int x = f(*c);
	cout << x << endl;
	cout << c->getX() << endl;
	cout << (*c).x << endl;
	c->setX(42);
	cout << x << endl;
	cout << c->getX() << endl;
	cout << (*c).x << endl;
	delete c;
	return 0;
}