#include <iostream> 
using namespace std; 

class GeometricObject { 
public: 
	int hoehe; 
	int breite; 
	GeometricObject(int h, int b);
	virtual float flaeche();
	float umfang();
}; 

class Quadrat : public GeometricObject { 
public: 
	Quadrat(int h);
}; 

class Kreis : public Quadrat { 
public: 
	Kreis(int h);
	virtual float flaeche();
	virtual float umfang();
}; 

GeometricObject::GeometricObject(int h, int b) : 
	hoehe(h), breite(b) {} 
	
float GeometricObject::flaeche() {
	return hoehe*breite;
} 

float GeometricObject::umfang() {
	return 2 * (hoehe + breite);
} 

Quadrat::Quadrat(int h) : GeometricObject(h, h) {} 

Kreis::Kreis(int h) : Quadrat(h) {} 

float Kreis::flaeche() {
	return 3.14 * breite * hoehe;
} 

float Kreis::umfang() {
	return 3.14 * breite;
} 

int main() { 
	Quadrat geo0 = Quadrat(10); 
	GeometricObject& geo1 = geo0; 
	GeometricObject geo2 = Kreis(5); 
	GeometricObject* geo3 = &geo2; 
	geo0.breite = 20; 
	cout << geo1.flaeche() << endl; 
	cout << geo1.umfang() << endl; 
	cout << geo2.flaeche() << endl; 
	cout << geo2.umfang() << endl; 
	cout << geo3->flaeche() << endl; 
	cout << geo3->umfang() << endl; 
	return 0; 
} 
